SUBDIRS_TEST = tb_shuffle tb_queen tbi_001
SUBDIRS = tb_shuffle tb_queen tbi_001 tb_usart tb_spi tb_int0 tb_tmr tb_rom

ROM_HDLS = ../../soc/rtavr.v 		\
	../../soc/rtavr_gpr_16.v	\
	../../soc/rtavr_ior.v		\
	../../soc/rtavr_s0_fetch.v	\
	../../soc/rtavr_s1_decode.v	\
	../../soc/rtavr_sram_2KB.v	\
	../../soc/rtavr_ior_port.v	\
	../../soc/rtavr_rom.v

HDL_DEFS = ../rtavr_defs.v 
ROM_SIZE = 2048

CLK_LIMIT = 2500
INST_LIMIT = 3000

#QUEEN_DEPTH = 5
#QUEEN_CLK_LIMIT = 20000
#QUEEN_INST_LIMIT = 20000
#QUEEN_DEPTH = 6
#QUEEN_CLK_LIMIT = 50000
#QUEEN_INST_LIMIT = 40000
#QUEEN_DEPTH = 7
#QUEEN_CLK_LIMIT = 200000
#QUEEN_INST_LIMIT = 150000
QUEEN_DEPTH = 8
QUEEN_CLK_LIMIT = 3000000
QUEEN_INST_LIMIT = 3000000

#SHUFFLE_LOOP_COUNT = 100
#SHUFFLE_CLK_LIMIT = 4000000
#SHUFFLE_INST_LIMIT = 3000000
SHUFFLE_LOOP_COUNT = 5
SHUFFLE_CLK_LIMIT = 20000
SHUFFLE_INST_LIMIT = 20000

MCU = attiny40
#MCU = attiny2313
#MCU = rtavr40

F_CPU=8000000UL
F_SCALER=1

COMMON = -mmcu=$(MCU)
COMMON += -mreduced-lddstd 

ROM_FLAGS = --assign rom_size=$(ROM_SIZE)
IHEX2V = ../../scripts/ihex2v.awk
IHEX2MEM = ../../scripts/ihex2mem.awk
DUMP2INST = ../../scripts/dump2inst.awk

AVR8L_TRACE = ../../avr8l_trace/avr8l_trace
DISASM = avr-objdump -mavr201 -d 
