#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )
#define sleep()   __asm__ volatile("sleep" )

uint8_t t_andi(uint8_t a) {
	a <<= 1;
	return (a & 0x80);
}

uint8_t t_and(uint8_t a, uint8_t b) {
	a <<= 1;
	return (a & b);
}

uint8_t t_or(uint8_t a, uint8_t b) {
	a <<= 1;
	return (a | b);
}

uint8_t t_eor(uint8_t a, uint8_t b) {
	a <<= 1;
	return (a ^ b);
}
